//18-enero-2013.
//Algoritmo para obtener la transformada Z^-1 del sistema introducido a la entrada, esto es, la secuencia de valores (coeficientes) de la señal original.
//No genera una función cerrada en tiempo discreto sino las muestras particulares.
clc
clear
exec('/home/arthur/Desktop/sci_stem.sce',-1);
z = %z;
num = 0.4673*z -0.3393;
den = z^2 - 1.5327*z + 0.6607;    //Debido a que Scilab no acepta numeros negativos, se multiplica por la unidad (z^2/z^2).

num2 = 10*z + 5;
den2 = (z-1)*(z-0.2);

num3 = 1;
den3 = z + 1;

Yz = num/den;
Yz2 = num2/den2;
Yz3 = num3/den3;

N = 50;    //Se desea observar 50 muestras.

deltakT = [1, zeros(1,N)];    //Se concatenan dos vectores para obtener la función impulso unitario.
deltakT2 = [1,zeros(1,N)];
deltakT3 = [1,zeros(1,N)];

//Simulación en tiempo discreto.
yk = flts(deltakT, Yz);    //La función de filtros realiza la simulación en tiempo discreto donde deltakT es el impulso alimentado a Yz que es el sistema discreto que se desea simular. La función flts permite simular la respuesta del sistema a una señal de entrada determinada, en este caso el impulso Yz.

yk2 = flts(deltakT2,Yz2);

yk3 = flts(deltakT3,Yz3);

scf();    //Se elaboran las graficas.
sci_stem([0:N], yk, 'red')
xgrid

scf();
sci_stem([0:N],yk2,'red')
xgrid

scf();
sci_stem([0:N],yk3,'red')
xgrid
ha = gca();
ha.data_bounds = [0 -1.5; 50 1.5]



//Utilizando el método de ecuaciones en diferencias.

N = 50;    //Cantidad de muestras.
//Señal de entrada.
x = [1,zeros(1,N)];
//Señal de entrada(solo una prealocación de memoria).
y = zeros(1,length(x));
//Sabiendo que el adelanto mayor era de 2 muestras, introducimos a mano los valores de las primeras dos muestras de salida.
//Salida y(0).
y(1) = 0;
//Salida y(1);
y(2) = 0.4673;
//Calculamos el resto de las muestras de forma iterativa.
for k=1:N-1
    y(k+2) = 1.5327*y(k+1)-0.6607*y(k)+0.4673*x(k+1)-0.3393*x(k);
end

//Graficamos.
scf();
sci_stem(0:N,y,'red')
xgrid


//Utilizando el método de ecuaciones en diferencias para (10z+5) / (z^2 -1.02z ´0.2)
N = 50;    //Cantidad de muestras.
//Señal de entrada.
x = [1,zeros(1,N)];
//Señal de entrada(solo una prealocación de memoria).
y = zeros(1,length(x));
//Sabiendo que el adelanto mayor era de 2 muestras, introducimos a mano los valores de las primeras dos muestras de salida.
//Salida y(0).
y(1) = 0;
//Salida y(1);
y(2) = 10;
//Calculamos el resto de las muestras de forma iterativa.
for k=1:N-1
    y(k+2) = 10*x(k+1) + 5*x(k) + 1.02*y(k+1) -0.2*y(k);
end

//Graficamos.
scf();
sci_stem(0:N,y,'red')
xgrid